package de.intevation.flys.artifacts.model.sq;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Sieve
{
    public double [] fractionSizes;

    protected List<List<SQ>> fractions;

    public Sieve() {
    }

    public Sieve(double [] fractionSizes) {
        this.fractionSizes = fractionSizes;
        fractions = new ArrayList<List<SQ>>(fractionSizes.length+1);
        for (int i = fractionSizes.length; i >= 0; --i) {
            fractions.add(new ArrayList<SQ>());
        }
    }

    public void sieve(Iterator<SQ> sqs) {
        OUTER: while (sqs.hasNext()) {
            SQ sq = sqs.next();
            double q = sq.getQ();
            for (int i = 0; i < fractionSizes.length; ++i) {
                if (q < fractionSizes[i]) {
                    fractions.get(i).add(sq);
                    continue OUTER;
                }
            }
            fractions.get(fractions.size()-1).add(sq);
        }
    }

    public int numFractions() {
        return fractions.size();
    }

    public List<SQ> getFraction(int idx) {
        return fractions.get(idx);
    }

    public void reset() {
        for (List<SQ> fraction: fractions) {
            fraction.clear();
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
